/*
 * sbug.h - Debugger functions
 *
 * Written 2003 by Werner Almesberger, Caltech Netlab FAST project
 */

#ifndef SBUG_H
#define SBUG_H

#include <inttypes.h>

#include "dwarfx.h"
#include "ptrace.h"

#include "data.h"
#include "op.h"
#include "stmt.h"


extern int sbug;
extern int debug;


/* ----- op.h -------------------------------------------------------------- */


struct value *sbug_op_member(struct value *value,const char *tag);

struct value *op_object(const struct op *self);
struct value *op_object_unit(const struct op *self);

struct value *op_address(const struct op *self);
struct value *op_dereference(const struct op *self);
struct value *op_ptr(const struct op *self);

int is_pointer(struct value **value);

int sbug_op_add(struct value *a,struct value *b,struct value **res);
int sbug_op_sub(struct value *a,struct value *b,struct value **res);

int sbug_assign_hook(struct value *lvalue,struct value **rvalue);


/* ----- Data access ------------------------------------------------------- */


struct value *dereference_object(struct value *value);


/* ----- Other functions --------------------------------------------------- */

int sbug_main(int argc,char **argv);

#endif /* SBUG_H */
