#
# Generate two executables _a and _b, each containing a compilation unit named
# _a.c or _b.c, respectively, containing:
#
# - global variables a, b, and c, with different locations and values
# - unit-local variables x, y, z, with different locations and values
# - static variables a, b, and c local to main, with different locations
#   and values
#
# Furthermore, _b contains a second compilation unit, called _c, with yet
# another arrangement of the local variables, and a static foo function.
# _c also contains the global variables, but with static storage class, plus
# a unit-local variable s that only exists in _c.
#
cat <<END >_a.c
int a = 1,b = 2,c = 3;
static int x = 4,y = 5,z = 6;

int main(void)
{
    static int a = 7,c = 8,b = 9;

label:
    return 0;
}
END
gcc -o _a -gdwarf-2 _a.c
cat <<END >_b.c
int c = 10,a = 11,b = 12;
static int y = 13,z = 14,x = 15;

int main(void)
{
    static int b = 16,c = 17,a = 18;

label:
    return 0;
}
END
cat <<END >_c.c
static int b = 20,a = 21,c = 22;
static int z = 23,y = 24,x = 25;
static s = 26;

static void foo(void)
{
    static int c = 27,b = 28,a = 29;
}
END
gcc -o _b -gdwarf-2 _b.c _c.c
rm _a.c _b.c _c.c
