/*
 * dwxloc.h - Location expressions
 *
 * Written 2002,2003 by Werner Almesberger, Caltech Netlab FAST project
 */


#ifndef DWXLOC_H
#define DWXLOC_H

#include <inttypes.h>

#include "arch.h"


struct dwx_loc {
    int reg;		/* register number, or -1 */
    arch_addr_t addr;	/* address; undefined if reg != -1 */
};

struct dwx_loc_expr {
    arch_addr_t start;
    arch_addr_t end; /* first address past last byte */
    const void *expr;
    int length;
    const struct dwx_loc_expr *next;
};


void dwx_loc_setup_hack(const struct arch_ops *ops,void *dsc,
  const struct dwx_loc_expr *fb);


arch_addr_t dwx_loc_comp(const void *expr,int length,arch_addr_t base);

struct dwx_loc dwx_loc_1(const struct dwx_loc_expr *loc_expr);
const struct dwx_loc_expr *dwx_loc_expr_here(const struct dwx_loc_expr *list,
  arch_addr_t addr);
struct dwx_loc dwx_loc_here(const struct dwx_loc_expr *list,arch_addr_t addr);

const struct dwx_loc_expr *dwx_loc_list(enum DW_FORM form,const void *pos);

#endif /* DWXLOC_H */
